<template>
    <div class="flex flex-col min-h-screen bg-gray-100 dark:bg-gray-900">
        <nav class="bg-white border-b border-gray-100  dark:bg-gray-900">
            <!-- Primary Navigation Menu -->
            <div class="max-w-7xl mx-auto px-4 sm:px-6 lg:px-8">
                <div class="flex justify-between h-16">
                    <div class="flex">
                        <!-- Logo -->
                        <div class="flex-shrink-0 flex items-center">
                            <a href="/dashboard">
                                <application-long-logo class="h-full w-auto" />
                            </a>
                        </div>

                        <!-- Navigation Links -->
                        <div class="hidden space-x-8 sm:-my-px sm:ml-10 sm:flex">
                            <nav-link href="/dashboard" :active="$page.currentRouteName == 'dashboard'">
                                <feather type="activity" class="h-5 text-black dark:text-gray-100 mr-1" /> Dashboard
                            </nav-link>
                            <nav-link v-if="!ownsFeature('displayManagement') || (ownsFeature('displayManagement') && hasPermission(['read-anything','read-displays','group:read-anything','group:read-displays']))"
                                href="/displays" :active="$page.currentRouteName == 'displays'">
                                <feather type="monitor" class="h-5 text-blue-600 dark:text-blue-500 mr-1" /> Displays
                            </nav-link>
                            <nav-link href="/shows" :active="$page.currentRouteName == 'shows'">
                                <feather type="video" class="h-5 text-red-700 dark:text-red-600 mr-1" /> Shows
                            </nav-link>
                            <nav-link href="/files" :active="path.startsWith('/files')">
                                <feather type="file" class="h-5 text-orange-600 mr-1" /> Files
                            </nav-link>
                            <nav-link v-if="ownsFeature('inventory')"
                                href="/inventory" :active="$page.currentRouteName == 'inventory'">
                                <feather type="list" class="h-5 mr-1 text-green-600 dark:text-green-500" /> Inventory
                            </nav-link>
                            <nav-link v-if="$page.user.current_organization_id === null && hasPermission(['read-anything','read-users','read-groups','read-orgs'])"
                                href="/users" :active="$page.currentRouteName == 'users'">
                                <feather type="users" class="h-5 text-yellow-600 dark:text-yellow-500 mr-1" /> Management
                            </nav-link>
                            <nav-link v-if="$page.user.current_organization_id !== null && hasAnyPermission(['read-anything','read-users','read-groups','read-orgs'])"
                                :href="'/organizations/' + $page.user.current_organization_id" :active="$page.currentRouteName == 'organization'">
                                <feather type="users" class="h-5 text-yellow-600 dark:text-yellow-500 mr-1" /> Management
                            </nav-link>
                            <nav-link href="/help" :active="$page.currentRouteName == 'help'">
                                <feather type="help-circle" class="h-5 text-gray-500 mr-1" /> Help
                            </nav-link>
                        </div>
                    </div>

                    <!-- Settings Dropdown -->
                    <div class="hidden sm:flex sm:items-center sm:ml-6">
                        <div class="ml-3 relative">
                            <dropdown align="right" width="48">
                                <template #trigger>
                                    <button class="flex text-sm border-2 border-transparent rounded-full focus:outline-none focus:border-gray-300 transition duration-150 ease-in-out">
                                        <img class="h-8 w-8 rounded-full object-cover" :src="$page.user.profile_photo_url" :alt="$page.user.name" />
                                    </button>
                                </template>

                                <template #content>
                                    <!-- Account Management -->
                                    <div class="block px-4 py-2 text-xs text-gray-400">
                                        Manage Account
                                    </div>

                                    <dropdown-link href="/user/profile">
                                        Profile
                                    </dropdown-link>

                                    <dropdown-link href="/user/api-tokens" v-if="$page.jetstream.hasApiFeatures">
                                        API Tokens
                                    </dropdown-link>

                                    <div class="border-t border-gray-100 dark:border-gray-900"></div>

                                    <template v-if="$page.user.organizations.length > 0">
                                        <div class="block px-4 py-2 text-xs text-gray-400 dark:text-gray-600">
                                            Switch Organization
                                        </div>

                                        <form @submit.prevent="switchToOrg(null)">
                                            <dropdown-link as="button">
                                                <div class="flex items-center">
                                                    <svg v-if="$page.user.current_organization_id === null" class="mr-2 h-5 w-5 text-green-400 dark:text-green-600" fill="none" stroke-linecap="round" stroke-linejoin="round" stroke-width="2" stroke="currentColor" viewBox="0 0 24 24"><path d="M9 12l2 2 4-4m6 2a9 9 0 11-18 0 9 9 0 0118 0z"></path></svg>
                                                    <div>Personal</div>
                                                </div>
                                            </dropdown-link>
                                        </form>

                                        <template v-for="organization in $page.user.organizations">
                                            <form @submit.prevent="switchToOrg(organization.id)" :key="organization.id">
                                                <dropdown-link as="button">
                                                    <div class="flex items-center">
                                                        <svg v-if="organization.id == $page.user.current_organization_id" class="mr-2 h-5 w-5 text-green-400 dark:text-green-600" fill="none" stroke-linecap="round" stroke-linejoin="round" stroke-width="2" stroke="currentColor" viewBox="0 0 24 24"><path d="M9 12l2 2 4-4m6 2a9 9 0 11-18 0 9 9 0 0118 0z"></path></svg>
                                                        <div>{{ organization.name }}</div>
                                                    </div>
                                                </dropdown-link>
                                            </form>
                                        </template>

                                        <div class="border-t border-gray-100 dark:border-gray-900"></div>
                                    </template>

                                    <!-- Authentication -->
                                    <form @submit.prevent="logout">
                                        <dropdown-link as="button">
                                            Logout
                                        </dropdown-link>
                                    </form>
                                </template>
                            </dropdown>
                        </div>
                    </div>

                    <!-- Hamburger -->
                    <div class="-mr-2 flex items-center sm:hidden">
                        <button @click="showingNavigationDropdown = ! showingNavigationDropdown" class="inline-flex items-center justify-center p-2 rounded-md text-gray-400 hover:text-gray-500 hover:bg-gray-100 focus:outline-none focus:bg-gray-100 focus:text-gray-500 transition duration-150 ease-in-out">
                            <svg class="h-6 w-6" stroke="currentColor" fill="none" viewBox="0 0 24 24">
                                <path :class="{'hidden': showingNavigationDropdown, 'inline-flex': ! showingNavigationDropdown }" stroke-linecap="round" stroke-linejoin="round" stroke-width="2" d="M4 6h16M4 12h16M4 18h16" />
                                <path :class="{'hidden': ! showingNavigationDropdown, 'inline-flex': showingNavigationDropdown }" stroke-linecap="round" stroke-linejoin="round" stroke-width="2" d="M6 18L18 6M6 6l12 12" />
                            </svg>
                        </button>
                    </div>
                </div>
            </div>

            <!-- Responsive Navigation Menu -->
            <div :class="{'block': showingNavigationDropdown, 'hidden': ! showingNavigationDropdown}" class="sm:hidden">
                <div class="pt-2 pb-3 space-y-1">
                    <responsive-nav-link href="/dashboard" :active="$page.currentRouteName == 'dashboard'">
                        Dashboard
                    </responsive-nav-link>
                </div>

                <!-- Responsive Settings Options -->
                <div class="pt-4 pb-1 border-t border-gray-200 dark:border-gray-800">
                    <div class="flex items-center px-4">
                        <div class="flex-shrink-0">
                            <img class="h-10 w-10 rounded-full" :src="$page.user.profile_photo_url" :alt="$page.user.name" />
                        </div>

                        <div class="ml-3">
                            <div class="font-medium text-base text-gray-800 dark:text-gray-200">{{ $page.user.name }}</div>
                            <div class="font-medium text-sm text-gray-500">{{ $page.user.email }}</div>
                        </div>
                    </div>

                    <div class="mt-3 space-y-1">
                        <responsive-nav-link href="/user/profile" :active="$page.currentRouteName == 'profile.show'">
                            Profile
                        </responsive-nav-link>

                        <responsive-nav-link href="/user/api-tokens" :active="$page.currentRouteName == 'api-tokens.index'" v-if="$page.jetstream.hasApiFeatures">
                            API Tokens
                        </responsive-nav-link>

                        <!-- Authentication -->
                        <form method="POST" @submit.prevent="logout">
                            <responsive-nav-link as="button">
                                Logout
                            </responsive-nav-link>
                        </form>

                        <template v-if="$page.user.organizations.length > 0">
                            <div class="border-t border-gray-200 dark:border-gray-800"></div>

                            <div class="block px-4 py-2 text-xs text-gray-400">
                                Switch Organization
                            </div>

                            <form @submit.prevent="switchToOrg(null)">
                                <responsive-nav-link as="button">
                                    <div class="flex items-center">
                                        <svg v-if="$page.user.current_organization_id === null" class="mr-2 h-5 w-5 text-green-400" fill="none" stroke-linecap="round" stroke-linejoin="round" stroke-width="2" stroke="currentColor" viewBox="0 0 24 24"><path d="M9 12l2 2 4-4m6 2a9 9 0 11-18 0 9 9 0 0118 0z"></path></svg>
                                        <div>Personal</div>
                                    </div>
                                </responsive-nav-link>
                            </form>

                            <template v-for="organization in $page.user.organizations">
                                <form @submit.prevent="switchToOrg(organization.id)" :key="organization.id">
                                    <responsive-nav-link as="button">
                                        <div class="flex items-center">
                                            <svg v-if="organization.id == $page.user.current_organization_id" class="mr-2 h-5 w-5 text-green-400" fill="none" stroke-linecap="round" stroke-linejoin="round" stroke-width="2" stroke="currentColor" viewBox="0 0 24 24"><path d="M9 12l2 2 4-4m6 2a9 9 0 11-18 0 9 9 0 0118 0z"></path></svg>
                                            <div>{{ organization.name }}</div>
                                        </div>
                                    </responsive-nav-link>
                                </form>
                            </template>
                        </template>
                    </div>
                </div>
            </div>
        </nav>

        <!-- Page Heading -->
        <header class="bg-white dark:bg-gray-800 dark:text-white shadow">
            <div class="max-w-7xl mx-auto py-6 px-4 sm:px-6 lg:px-8">
                <h2 class="font-semibold text-xl text-gray-800 dark:text-gray-200 leading-tight">
                    <slot name="header"></slot>
                </h2>
            </div>
        </header>

        <!-- Page Content -->
        <main class="py-8 flex-grow">
            <div class="max-w-7xl mx-auto sm:px-6 lg:px-8">
                <slot></slot>
            </div>
        </main>

        <!-- Page Footer -->
        <footer class="bottom-0 w-full bg-white dark:bg-black border-b border-gray-100 dark:border-gray-900 dark:text-white py-2">
            <div class="max-w-7xl mx-auto px-4 sm:px-6 lg:px-8">
                <div class="flex justify-between">
                    <div class="flex">
                        &copy;2020 ChurchTech.Help GNU GPLv3
                    </div>
                </div>
            </div>
        </footer>

        <!-- Modal Portal -->
        <portal-target name="modal" multiple>
        </portal-target>
    </div>
</template>

<script>
    import ApplicationLongLogo from './../Components/ApplicationLongLogo'
    import ApplicationMark from './../Components/ApplicationMark'
    import Dropdown from './../Components/Dropdown'
    import DropdownLink from './../Components/DropdownLink'
    import NavLink from './../Components/NavLink'
    import ResponsiveNavLink from './../Components/ResponsiveNavLink'

    export default {
        name: 'AppLayout',
        components: {
            ApplicationLongLogo,
            ApplicationMark,
            Dropdown,
            DropdownLink,
            NavLink,
            ResponsiveNavLink,
        },

        data() {
            return {
                showingNavigationDropdown: false,
            }
        },

        methods: {
            switchToOrg(org) {
                this.$inertia.put('/user/organization/' + org);
            },

            logout() {
                axios.post('/logout').then(response => {
                    window.location = '/';
                });
            },
        },

        computed: {
            path() {
                return window.location.pathname;
            }
        }
    }
</script>
